(expect "when - true condition"
        (equal 'ok (when t 'ok)))

(expect "when - false condition"
        (null (when nil 'fail)))

(let ((a 'ok))
  (when nil (set a 'fail))
  (expect "when - does not evaluate on false" (equal a 'ok)))

(expect "when - without body returns nil"
        (null (when t)))

(expect "when - implicit progn"
        (equal 'ok (when t 'wrong 'wrong2 'ok)))
