(let ((a 5) (b 6))
  (expect "a is 5" (= a 5))
  (expect "b is 6" (= b 6))
  )

(let ((a 'top))
  (let ((a 'shadow)
        (b a))
    (expect "let - non incremental context"
            (equal b 'top))))

(let ((a 'top))
  (let* ((a 'shadow)
         (b a))
    (expect "let* - Incremental context"
            (equal b 'shadow))))
