#!/usr/bin/env perl

use strict;
use warnings;
use FindBin;
use lib "$FindBin::Bin/../lib";
use Minilisp;

my $scriptfile = shift;

die "No script file provided." unless defined $scriptfile && -f $scriptfile;

my $parsed = Minilisp::compile_file($scriptfile);

$parsed->();

exit 0;
